///////////////////////////////////////////
//																       //
//  Definition of Fraction Class         //
//																       //
//					Chungho Chau					       //
//																       //
///////////////////////////////////////////

#ifndef FRACTION_CLASS  
#define FRACTION_CLASS

#include "Generic.h"
#include <iostream.h>


class Fraction{

	friend ostream & operator<< (ostream &, const Fraction &);
	friend Fraction operator+ (int, const Fraction &);
	friend Fraction operator- (int, const Fraction &);
	friend Fraction operator* (int, const Fraction &);
	friend Fraction operator/ (int, const Fraction &);


	public:
					//ctor
					Fraction(int num=0, int den=1) 
						: m_num(num), m_den(den) {}

					// dtor
					~Fraction(void) {}

					// cctor
					Fraction(const Fraction &other);

					// Get Numerator
					int Get_Num(void) const
						{return m_num;}

					// Get Denomintor
					int Get_Den (void) const
						{return m_den;}

					// op=
					Fraction & operator=(const Fraction &other);
					Fraction & operator=(int other);

					// op==
					BOOL operator== (const Fraction &other);
					BOOL operator== (int other);

					// same functionality as operator<<
					void Display (BOOL needCRLF = FALSE) const;

					// op+=
					void operator+= (const Fraction &other);
					void operator+= (int other);

					// op-=
					void operator-= (const Fraction &other);
					void operator-= (int other);

					// op*=
					void operator*= (const Fraction &other);
					void operator*= (int other);

					// op/=
					void operator/= (const Fraction &other);
					void operator/= (int other);
										
					// op+
					Fraction operator+ (const Fraction &other);
					Fraction operator+ (int other);
					
					// op-
					Fraction operator- (const Fraction &other);
					Fraction operator- (int other);

					// op*
					Fraction operator* (const Fraction &other);
					Fraction operator* (int other);
					
					// op/
					Fraction operator/ (const Fraction &other);
					Fraction operator/ (int other);

					





				
	private:
					int m_num;		// numerator
					int m_den;		// denominator


};

#endif