///////////////////////////////////////////
//																       //
//  Implementaion of DoubleNumber Class  //
//																       //
//					Chungho Chau					       //
//																       //
///////////////////////////////////////////

#include "DoubleNumber.h"
#include <math.h>


//--------------------------------------------------------------------------------
//	ctor
//-------------------------------------------------------------------------------- 
DoubleNumber::DoubleNumber(const double in_data, const char *in_string)
	: Number(in_string)	
{
	m_data   = in_data;
	count_total   += 1;
	count_current += 1;
}


//--------------------------------------------------------------------------------
//	dtor
//-------------------------------------------------------------------------------- 
DoubleNumber::~DoubleNumber()
{
	count_current -= 1;
}



//--------------------------------------------------------------------------------
//	Display function
//-------------------------------------------------------------------------------- 
void DoubleNumber::Display(BOOL needCRLF) const
{
	m_string.Display();	
	cout << " and my data is " << m_data;
	
	if (needCRLF)
		cout << '\n';
}



//--------------------------------------------------------------------------------
//	Operator= for DoubleNumber object
//-------------------------------------------------------------------------------- 
DoubleNumber &DoubleNumber::operator= (const DoubleNumber &other)
{
	m_data = other.m_data;
	return *this;
}



//--------------------------------------------------------------------------------
//	Operator= for Double number
//-------------------------------------------------------------------------------- 
DoubleNumber &DoubleNumber::operator= (double other)
{
	m_data = other;
	return *this;
}


//--------------------------------------------------------------------------------
//	Conversion to class Fraction object
//-------------------------------------------------------------------------------- 
DoubleNumber::operator Fraction(void) const
{
	int i=1;  // feel really good when I fig this out
	while  ( (m_data*i - int(m_data*i)) > 0.0  )
		{	i *= 10;}	
	
	Fraction temp(m_data*i, i);
	return temp;	
}



//--------------------------------------------------------------------------------
//	Operator= for class Fraction object
//-------------------------------------------------------------------------------- 
DoubleNumber &DoubleNumber::operator= (const Fraction &other)
{
	m_data = (double)other.Get_Num() / (double)other.Get_Den();
	return *this;
}
