///////////////////////////////////////////
//																       //
//  Definition of DoubleNumber Class     //
//																       //
//					Chungho Chau					       //
//																       //
///////////////////////////////////////////

#ifndef DOUBLENUMBER_CLASS  
#define DOUBLENUMBER_CLASS


#include "Number.h"
#include "VString.h"
#include "Fraction.h"


class DoubleNumber : public Number {

	public:
				// ctor
				DoubleNumber(const double in_data, const char *in_string);
			
				~DoubleNumber();

				virtual void Display(BOOL needCRLF = FALSE) const;

				// op=
				DoubleNumber &operator= (const DoubleNumber &);
				DoubleNumber &operator= (double);
				DoubleNumber &operator= (const Fraction &);

				// convertion to class Fraction
				operator Fraction(void) const;

	private:
				double  m_data;
			//	VString m_string;

				DoubleNumber (const DoubleNumber &other);
				DoubleNumber &operator== (const DoubleNumber &);
				
};

#endif