///////////////////////////////////////////
//																       //
//  Implementaion of Fraction Class      //
//																       //
//					Chungho Chau					       //
//																       //
///////////////////////////////////////////

#include "Fraction.h"
#include <iostream.h>

//--------------------------------------------------------------------------------
//	Copy Constructor
//-------------------------------------------------------------------------------- 
Fraction::Fraction(const Fraction &other)
{
	m_num = other.m_num;
	m_den = other.m_den;
}


//--------------------------------------------------------------------------------
//	Assignment Operator for Fraction object
//-------------------------------------------------------------------------------- 
Fraction &Fraction::operator=(const Fraction &other)
{
	if (*this==other)
		return *this;

	m_num = other.m_num;
	m_den = other.m_den;
	return *this;
}


//--------------------------------------------------------------------------------
//	Assignment Operator for Integer
//-------------------------------------------------------------------------------- 
Fraction &Fraction::operator=(int other)
{
	if (*this==other)
		return *this;

	m_num = other;
	m_den = 1;
	return *this;
}


//--------------------------------------------------------------------------------
//	Comparison Operator for Fraction object
//-------------------------------------------------------------------------------- 
BOOL Fraction::operator== (const Fraction &other)
{
	if ((m_num==other.m_num) && (m_den==other.m_den))
		return TRUE;
	else
		return FALSE;
}


//--------------------------------------------------------------------------------
//	Comparison Operator for Integer
//-------------------------------------------------------------------------------- 
BOOL Fraction::operator== (int other)
{
	if (m_num==other)
		return TRUE;
	else
		return FALSE;
}


//--------------------------------------------------------------------------------
//	Display Fraction objects
//-------------------------------------------------------------------------------- 
void Fraction::Display (BOOL needCRLF) const
{
	cout << m_num << "/" << m_den;
	if (needCRLF)
		cout << '\n';
}

//--------------------------------------------------------------------------------
//	Operator+ for "Fraction + Fraction"
//-------------------------------------------------------------------------------- 
Fraction Fraction::operator+ (const Fraction &other) const
{
	Fraction newF(*this);
	newF += other;
	return newF;
	
	// or it can be done as followed
	// newF.m_num = (m_num * other.m_den) + (m_den * other.m_num);
	// newF.m_den = m_den * other.m_den;		// m_den == this->m_den	
}


//--------------------------------------------------------------------------------
//	Operator+ for "Fraction + Integer"
//  without this, it still works
//  compiler will go to ctor and then op+ for Fraction + Fraction
//-------------------------------------------------------------------------------- 
Fraction Fraction::operator+ (int other) const
{ 
	Fraction newF(*this);
	newF += other;
	return newF;
}


//--------------------------------------------------------------------------------
//	Operator+= for Fraction object
//-------------------------------------------------------------------------------- 
void Fraction::operator+= (const Fraction &other)
{
	m_num = (m_num * other.m_den) + (m_den * other.m_num);
	m_den = m_den * other.m_den;	
}


//--------------------------------------------------------------------------------
//	Operator+= for integer 
//-------------------------------------------------------------------------------- 
void Fraction::operator+= (int other)
{
	m_num = m_num + m_den * other;	
}


//--------------------------------------------------------------------------------
//	Operator-= for Fraction object
//-------------------------------------------------------------------------------- 
void Fraction::operator-= (const Fraction &other)
{
	m_num = (m_num * other.m_den) - (m_den * other.m_num);
	m_den = m_den * other.m_den;	
}


//--------------------------------------------------------------------------------
//	Operator-= for integer 
//-------------------------------------------------------------------------------- 
void Fraction::operator-= (int other)
{
	m_num = m_num - m_den * other;
}


//--------------------------------------------------------------------------------
//	Operator- for "Fraction - Fraction"
//-------------------------------------------------------------------------------- 
Fraction Fraction::operator- (const Fraction &other) const
{
	Fraction newF(*this);
	newF -= other;
	return newF;

}


//--------------------------------------------------------------------------------
//	Operator- for "Fraction - Integer"
//-------------------------------------------------------------------------------- 
Fraction Fraction::operator- (int other) const
{ 
	Fraction newF(*this);
	newF -= other;
	return newF;
}


//--------------------------------------------------------------------------------
//	Operator*= for Fraction object
//-------------------------------------------------------------------------------- 
void Fraction::operator*= (const Fraction &other) 
{
	m_num = m_num * other.m_num;
	m_den = m_den * other.m_den;	
}


//--------------------------------------------------------------------------------
//	Operator*= for integer 
//-------------------------------------------------------------------------------- 
void Fraction::operator*= (int other) 
{
	m_num = m_num * other;	
}


//--------------------------------------------------------------------------------
//	Operator/= for Fraction object
//-------------------------------------------------------------------------------- 
void Fraction::operator/= (const Fraction &other)
{
	m_num = m_num * other.m_den;
	m_den = m_den * other.m_num;	
}


//--------------------------------------------------------------------------------
//	Operator/= for integer 
//-------------------------------------------------------------------------------- 
void Fraction::operator/= (int other)
{
	m_den = m_den * other;	
}


//--------------------------------------------------------------------------------
//	Operator* for "Fraction * Fraction"
//-------------------------------------------------------------------------------- 
Fraction Fraction::operator* (const Fraction &other) const
{
	Fraction newF(*this);
	newF *= other;
	return newF;

}


//--------------------------------------------------------------------------------
//	Operator* for "Fraction * Integer"
//-------------------------------------------------------------------------------- 
Fraction Fraction::operator* (int other) const
{ 
	Fraction newF(*this);
	newF *= other;
	return newF;
}

//--------------------------------------------------------------------------------
//	Operator/ for "Fraction / Fraction"
//-------------------------------------------------------------------------------- 
Fraction Fraction::operator/ (const Fraction &other) const
{
	Fraction newF(*this);
	newF /= other;
	return newF;

}


//--------------------------------------------------------------------------------
//	Operator/ for "Fraction / Integer"
//-------------------------------------------------------------------------------- 
Fraction Fraction::operator/ (int other) const
{ 
	Fraction newF(*this);
	newF /= other;
	return newF;
}


//--------------------------------------------------------------------------------
//	Operator+ for c = +a
//-------------------------------------------------------------------------------- 
Fraction Fraction::operator+ (void) const
{
	return *this;
}


//--------------------------------------------------------------------------------
//	Operator+ for c = -a
//-------------------------------------------------------------------------------- 
Fraction Fraction::operator- (void) const
{
	Fraction newF( -m_num, m_den);
	return newF;
}


//--------------------------------------------------------------------------------
//	Operator+ for ++a
//-------------------------------------------------------------------------------- 
Fraction &Fraction::operator++ (void)
{
	m_num += m_den;  // increment by one
	return *this;
}



//--------------------------------------------------------------------------------
//	Operator+ for --a
//-------------------------------------------------------------------------------- 
Fraction &Fraction::operator-- (void)
{
	m_num -= m_den;  // decrement by one
	return *this;
}

// **** The following are Globle functions implementation ****


//--------------------------------------------------------------------------------
//	Globle function to overload op<<
//-------------------------------------------------------------------------------- 
ostream & operator<< (ostream &output, const Fraction &other)
{
	output << "[" << other.m_num << "/" << other.m_den << "]";
	return output;
}


//--------------------------------------------------------------------------------
//	Globle function to perform "Integer + Fraction object"
//-------------------------------------------------------------------------------- 
Fraction operator+ (int temp, const Fraction &other) 
{
	Fraction newF(temp);
	newF += other;
	return newF;
}


//--------------------------------------------------------------------------------
//	Globle function to perform "Integer - Fraction object"
//-------------------------------------------------------------------------------- 
Fraction operator- (int temp, const Fraction &other) 
{
	Fraction newF(temp);
	newF -= other;
	return newF;
}


//--------------------------------------------------------------------------------
//	Globle function to perform "Integer * Fraction object"
//-------------------------------------------------------------------------------- 
Fraction operator* (int temp, const Fraction &other)
{
	Fraction newF(temp);
	newF *= other;
	return newF;
}


//--------------------------------------------------------------------------------
//	Globle function to perform "Integer / Fraction object"
//-------------------------------------------------------------------------------- 
Fraction operator/ (int temp, const Fraction &other) 
{
	Fraction newF(temp);
	newF /= other;
	return newF;
}


