///////////////////////////////////////////
//																       //
//  Implementaion of IntNumber Class     //
//																       //
//					Chungho Chau					       //
//																       //
///////////////////////////////////////////

#include "IntNumber.h"


//--------------------------------------------------------------------------------
//	ctor
//-------------------------------------------------------------------------------- 
IntNumber::IntNumber(const int in_data, const char *in_string)
	: Number(in_string)
{
	m_data   = in_data;
	count_total   += 1;
	count_current += 1;
}


//--------------------------------------------------------------------------------
//	dtor
//-------------------------------------------------------------------------------- 
IntNumber::~IntNumber()
{
	count_current -= 1;
}


//--------------------------------------------------------------------------------
//	Display function
//-------------------------------------------------------------------------------- 
void IntNumber::Display(BOOL needCRLF) const
{
	m_string.Display();	
	cout << " and my data is " << m_data;
	
	if (needCRLF)
		cout << '\n';
}


//--------------------------------------------------------------------------------
//	Operator= for Integer Number object
//-------------------------------------------------------------------------------- 
IntNumber &IntNumber::operator= (const IntNumber &other)
{
	m_data = other.m_data;
	return *this;
}


//--------------------------------------------------------------------------------
//	Operator= for Integer 
//-------------------------------------------------------------------------------- 
IntNumber &IntNumber::operator= (int other)
{
	m_data = other;
	return *this;
}


//--------------------------------------------------------------------------------
//	Conversion to Build-in type Float
//-------------------------------------------------------------------------------- 
IntNumber::operator float(void) const
{
	return (float)m_data;
}


//--------------------------------------------------------------------------------
//	Conversion to other class Fraction
//-------------------------------------------------------------------------------- 
IntNumber::operator Fraction(void) const
{
	Fraction temp(m_data);
	return temp;
}


//--------------------------------------------------------------------------------
//	Operator= for Fraction class object 
//-------------------------------------------------------------------------------- 
IntNumber &IntNumber::operator= (const Fraction &other)
{
	m_data = other.Get_Num() / other.Get_Den();
	return *this;
}
