///////////////////////////////////////////
//																       //
//  Definition of IntNumber Class        //
//																       //
//					Chungho Chau					       //
//																       //
///////////////////////////////////////////

#ifndef INTNUMBER_CLASS  
#define INTNUMBER_CLASS


#include "Number.h"
#include "VString.h"
#include "Fraction.h"


class IntNumber : public Number {

	public:
				// ctor
				IntNumber(const int in_data, const char *in_string);

				// ctor
				IntNumber(const Fraction &other);

				~IntNumber();

				virtual void Display(BOOL needCRLF = FALSE) const;

				// op=
				IntNumber &operator= (const IntNumber &);
				IntNumber &operator= (int);
				IntNumber &operator= (const Fraction &);

				// convertion to float
				operator float(void) const;

				// convertion to class Fraction
				operator Fraction(void) const;

	private:
				int  m_data;
				
				IntNumber (const IntNumber &other);			
				BOOL &operator== (const IntNumber &);
				
};

#endif